//@author: antokhio
//@help: template for compute shaders
//@tags: CS, template
//@credits: 

struct Brush
{
	float4x4 Transform;
	int TexID;
};

//StructuredBuffer<float4> color <bool color=true;>;

Texture2D tex0;
SamplerState s0:IMMUTABLE {Filter=MIN_MAG_MIP_LINEAR;AddressU=CLAMP;AddressV=CLAMP;};

RWStructuredBuffer<Brush> Output : BACKBUFFER;

bool Clear;
uint InstanceStartIndex;

[numthreads(1, 1, 1)]
void CS( uint3 tid : SV_DispatchThreadID )
{
	uint idx = tid.x + InstanceStartIndex;
	if (Clear)
	{
		Output[idx].Transform = float4x4 (0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);
		Output[idx].TexID = 0;
	}
}


technique11 Template
{
	pass P0
	{
		SetComputeShader( CompileShader( cs_5_0, CS() ) );
	}
}




